#version 430

layout (location = 0) in vec3 pos;
layout (location = 1) in vec4 color;
layout (location = 2) in vec2 tex;

uniform sampler2D samp;

uniform mat4 projMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;

uniform bool useTexture;
uniform bool useColor;
uniform bool useMixColor;
uniform vec4 mixColor;

out vec2 tc;
out vec4 outColor;

void main(void)
{ 
    tc = tex; 
    outColor = color;
    gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0);
}